C
C                           PRELND3 VERSION 2.0
C                  COPYRIGHT  1996  ALL RIGHTS RESERVED        
C                 SYSTEMS APPLICATIONS INTERNATIONAL, INC. 
C                           December 30, 1996
      INTEGER FUNCTION INSIDE (X,Y,NPTS,PTS)
C
C     *** DETERMINES IF A POINT IS INSIDE A POLYGON
C             GW LUNDBERG/SAI  APRIL '83
C
C         X,Y   THE POINT IN DATA UNITS
C         NPTS  THE NUMBER OF POINTS IN THE POLYGON
C         PTS   THE ARRAY OF POLYGON POINTS (X,Y) IN DATA SPACE
C
C     *** NOTE -- TO INCLUDE BOUNDARY, SET INSIDE = 1
C                 AT $200, TO EXCLUDE BOUNDARY, SET
C                 INSIDE = 0 AT $200.
C
      DIMENSION PTS(2,1)
C
C     ---------------------------------------------------------
C
C     RESET CROSSINGS COUNT
      KNT = 0
C
C     *** LOOP OVER ALL LINE SEGMENTS OF POLYGON
      DO 100 I=1,NPTS
         IP1 = I+1
C
C        *** ADJUST FOR WRAP AROUND
         IF (I .EQ. NPTS) IP1 = 1
C
C        *** TRANSLATE SO THAT (X,Y) IS THE ORIGIN
         X1 = PTS(1,I) - X
         Y1 = PTS(2,I) - Y
C
C        *** CHECK IF (X,Y) ON THIS NODE POINT
         IF (X1 .EQ. 0.  .AND.  Y1 .EQ. 0.) GO TO 200
C
         X2 = PTS(1,IP1) - X
         Y2 = PTS(2,IP1) - Y
C
C        *** DIRECT SEGMENT SO THAT X2>=X1
         IF (X2 .GE. X1) GO TO 20
         T = X1
         X1 = X2
         X2 = T
         T = Y1
         Y1 = Y2
         Y2 = T
C
C        *** IF HIGH X BELOW Y-AXIS -- IGNORE THIS SEGMENT
   20    IF (X2 .LT. 0.) GO TO 100
C
C        *** IF LOW X BELOW Y-AXIS -- PUNT
         IF (X1 .LT. 0.) GO TO 30
C
C        *** CAN CROSS POSITIVE X-RAY ONLY IF SIGNS DIFFER
         IF (SIGN(1.,Y1) .EQ. SIGN(1.,Y2)) GO TO 100
C
C        *** CROSSES -- CHECK ON BOUNDARY
         IF (X1 .EQ. 0.  .AND.  X2 .EQ. 0.) GO TO 200
C
C        *** VALID CROSSING
         GO TO 90
C
C
C        *** REDETERMINE Y1 AT Y-AXIS AND TEST AGAIN
   30    CONTINUE
         Y1 = -X1*(Y2-Y1)/(X2-X1) + Y1
C
C        *** CHECK ON BOUNDARY
   40    IF (Y1 .EQ. 0.) GO TO 200
C
C        *** CHECK ON CROSSING
         IF (SIGN(1.,Y1) .EQ. SIGN(1.,Y2)) GO TO 100
C
C        *** CROSSES -- BUMP CROSSING COUNT
   90    KNT = KNT+1
  100 CONTINUE
C
C     *** POINT INSIDE IF COUNT ODD
C**
C**INSIDE = RT (KNT,1)
C**
C** MODIFIED 11/87 SAI/REM TO ASSURE COMPUTER TRANSPORTABILITY (ARM3-1.0)
      INSIDE=MOD(KNT,2)
      RETURN
C
C     *** ON BOUNDARY -- HENCE -- INSIDE
  200 INSIDE = 1
      RETURN
      END
