CDECK MAPGTU
C                           PRELND3 VERSION 2.0
C                  COPYRIGHT  1996  ALL RIGHTS RESERVED        
C                 SYSTEMS APPLICATIONS INTERNATIONAL, INC. 
C                           December 30, 1996
      SUBROUTINE MAPGTU (ALON,ALAT,IZONE,UTMX,UTMY)
      SAVE
C
C     *** CONVERTS LATITUDE AND LONGITUDE TO UTM COORDINATES
C         THIS IS A MODIFICATION OF THE US GEOLOGICAL SURVEY
C         PROGRAM NO J380 (TOPOGRAPHIC DIVISION)
C             GW LUNDBERG/SAI  APR 79
C
C         ALON    LONGITUDE IN DEGREES (WESTERN HEMISPHERE IS NEGATIVE)
C         ALAT    LATITUDE IN DEGREES
C         IZONE   ZONE OVERRIDE IF NOT ZERO
C         UTMX    EASTING (KM)
C         UTMY    NORTHING (KM)
C
C     MODIFIED 9/23/87 FOR IBM PC LAHEY FORTRAN      RGJ
C
C     MODIFIED 8/26/88 FOR MULTIFLOW COMPUTER   RGJ
C
C     MODIFIED 4/25/90 ADDED COMMENTS "C.."; TO ALLOW SPANNING
C                      MORE THAN TWO ZONES    MMJ
C
      DIMENSION B(12)
      COMMON /VVUTM/ A(16)
C
      SLAT = ALAT*3600.
      SLON = -ALON*3600.
C
C     *** COMPUTE COEFFICIENTS FOR CONVERSION
      CALL VVGTU1
C
C     *** TEST FOR ZONE INPUT ON GEODETIC TO UTM INDICATING OVERRIDE OF
C         NORMAL 6 DEGREE LONGITUDE BAND.
C
      IF(IZONE.EQ.0)GO TO 30
C
C     *** COMPUTE CENTRAL MERIDIAM IN SECONDS FOR ENFORCED ZONE.
      IF(IABS(IZONE)-30)10,10,20
   10 UTZ=30.0-IABS(IZONE)
      A(9)=((UTZ*6.0)+3.0)*3600.0
      GO TO 40
   20 UTZ=IABS(IZONE)-30.0
      A(9)=((UTZ*6.0)-3.0)*(-3600.0)
      GO TO 40
C
C     *** COMPUTE UTM ZONE(IZONE) AND CENTRAL MERIDIAN IN SECONDS(A9)
C         FOR GEODETIC TO UTM CONVERSION WHERE ZONE IS NOT INPUT.
C
   30 IZONE=30-(INT(SLON)/21600)
      UTZ=30.0-IZONE
      A(9)=((UTZ*6.0)+3.0)*3600.0
C
C     *** CONVERT GEODETIC TO UTM COORDINATES
C
C     *** RETURNS ZEROS IF LATITUDE EXCEEDS 84 DEGREES OR LONGITUDE
C         0.16 RADIANS
   40 CONTINUE
C..40 IF(ABS(SLAT)-302400.0) 80,80,70
C..70 X=0.0
C..   Y=0.0
C..   GO TO 99
   80 B(10)=(A(9)-SLON) *4.848181109536E-6
C..   IF(ABS(B(10))-0.16)90,90,70
   90 B(9)=SLAT*4.848136811095E-6
      SINP=SIN(B(9))
      COSP=COS(B(9))
      RN=A(15)/SQRT(1.0-A(16)*SINP*SINP)
      T=SINP/COSP
      TS=T*T
      B(11)=COSP*COSP
      ETAS=A(16)*B(11)/(1.0-A(16))
      B(1)=RN*COSP
      B(3)=(1.0-TS+ETAS)*B(1)*B(11)/6.0
      B(5)=((TS-18.0)*TS+5.0+(14.0-58.0*TS)*ETAS)*B(1)*B(11)*
     $ B(11)/120.0
      B(7)=(((179.0-TS)*TS-479.0)*TS+61.0)*B(1)*B(11)**3/5040.0
      B(12)=B(10)*B(10)
      X=(((B(7)*B(12)+B(5))*B(12)+B(3))*B(12)+B(1))*B(10)*A(8)+
     $  A(5)
      B(2)=RN*B(11)*T/2.0
      B(4)=(ETAS*(9.0+4.0*ETAS)+5.0-TS)*B(2)*B(11)/12.0
      B(6)=((TS-58.0)*TS+61.0+(270.0-330.0*TS)*ETAS)*B(2)*
     $ B(11)*B(11)/360.0
      B(8)=(((543.0-TS)*TS-3111.0)*TS+1385.0)*B(2)*B(11)**3/
     $ 20160.0
      Y=(((B(8)*B(12)+B(6))*B(12)+B(4))*B(12)+B(2))*B(12)+
     $ ((((A(4)*B(11)+A(3))*B(11)+A(2))*B(11)+A(1))*SINP*COSP+B(9))
     $ *A(10)
      Y=(Y-A(7))*A(8)+A(6)
C
   99 UTMX = X/1000.
      UTMY = Y/1000.
      RETURN
      END
