CDECK MAPUTG *********************************************************
C                           PRELND3 VERSION 2.0
C                  COPYRIGHT  1996  ALL RIGHTS RESERVED        
C                 SYSTEMS APPLICATIONS INTERNATIONAL, INC. 
C                           December 30, 1996
      SUBROUTINE MAPUTG (UTMX,UTMY,IZONE,ALON,ALAT)
C
C     *** CONVERTS UTM COORDINATES TO LATITUDE AND LONGITUDE
C         THIS IS A MODIFICATION OF THE US GEOLOGICAL SURVEY
C         PROGRAM NO J380  (TOPOGRAPHIC DIVISION)
C             GW LUNDBERG/SAI  APR 79
C
C         UTMX    EASTING IN KILOMETERS
C         UTMY    NORTHING IN KILOMETERS
C         IZONE   UTM ZONE NUMBER
C         ALON    LONGITUDE IN DEGREES
C         ALAT    LATITUDE IN DEGREES
C
      DIMENSION B(12)
      COMMON /VVUTM/ A(16)
C
      X = UTMX*1000.
      Y = UTMY*1000.
C
C     *** COMPUTE CONVERSION COEFFICIENTS IF NEEDED
      CALL VVGTU1
C
C     *** COMPUTE CENTRAL MERIDIAN IN SECONDS FROM IZONE INPUT
   10 UTZ = 30.0 - IABS (IZONE)
      A(9) = ((UTZ*6.0) + 3.0) * 3600.0
C
C     *** CONVERT UTM COORDINATES TO GEODETIC
      B(9)=((A(5)-X)*1.0E-6)/A(8)
c     IF (ABS(B(9))-1.0E-7*A(15)*2.0)30,30,20
c  20 SLAT=0.0
c     SLON=0.0
c     GO TO 99
   30 B(10)=((Y-A(6))/A(8)+A(7))/A(10)
c     IF(ABS(B(10))-1.47E0)40,40,20
   40 SINW=SIN(B(10))
      COSW=COS(B(10))
      B(12)=COSW*COSW
      B(11)=(((A(14)*B(12)+A(13))*B(12)+A(12))*B(12)+A(11))*SINW*COSW
     $ +B(10)
      SINW=SIN(B(11))
      COSW=COS(B(11))
      RN=SQRT(1.0-A(16)*SINW*SINW)*1.0E6/A(15)
      T=SINW/COSW
      TS=T*T
      B(12)=COSW*COSW
      ETAS=A(16)*B(12)/(1.0-A(16))
      B(1)=RN/COSW
      B(2)=-T*(1.0+ETAS)*RN*RN/2.0
      B(3)=-(1.0+2.0*TS+ETAS)*B(1)*RN*RN/6.0
      B(4)=(((-6.0-ETAS*9.0)*ETAS+3.0)*TS+(6.0-ETAS*3.0)*ETAS
     $ +5.0)*T*RN**4/24.0
      B(5)=((TS*24.0+ETAS*8.0+28.0)*TS+ETAS*6.0+5.0)*B(1)*
     $ RN**4/120.0
      B(6)=(((ETAS*45.0-45.0)*TS+ETAS*162.0-90.0)*TS
     $ -ETAS*107.0-61.0)*T*RN**6/720.0
      B(7)=-(((TS*720.0+1320.0)*TS+662.0)*TS+61.0)*B(1)*RN**6/
     $ 5040.0
      B(8)=(((TS*1575.0+4095.0)*TS+3633.0)*TS+1385.0)*T*RN**8/
     $ 40320.0
      B(10)=B(9)*B(9)
      SLAT=((((B(8)*B(10)+B(6))*B(10)+B(4))*B(10)+B(2))*B(10)+B(11))*
     $ 206264.80624709
      SLON= (((B(7)*B(10)+B(5))*B(10)+B(3))*B(10)+B(1))*B(9)*
     $ 206264.80624709 + A(9)
C
C     *** CONVERT SECONDS OF ARC TO DEGREES AND RETURN
   99 ALAT = SLAT/3600.
      ALON = -SLON/3600.
C
      RETURN
      END
