C     PROGRAM PRELND
C                             PRELND3 Version 2.0 
C                  COPYRIGHT 1992, 1995, 1996    ALL RIGHTS RESERVED    
C                 SYSTEMS APPLICATIONS INTERNATIONAL, INC. 
C                              December 30, 1996
c Version 2.0 of PRELND3 is a component of Version 1.24 of the UAM-V
c modeling system and its use is therefore restricted as follows: 
C Version 1.24 of the UAM-V modeling system is protected by Registered Copyrights
C owned by the Systems Applications International, Inc. Version 1.24 of the UAM-V
C modeling system may be used by or on behalf of the United States Governmant and
C other U.S. governmental entities (including state, regional and local agencies)
C for bona fide governmental purposes, which includes use by non-governmental
C entities for ozone modeling performed in conjunction with and as a participant
C in the Ozone Transport Assessment Group (OTAG). Use of the downloaded UAM-V
C modeling system or any portion thereof (a) to prepare any derivative model, 
C modeling system or component of any modeling system,(b) to adapt or to install
C any portion of the UAM-V modeling system to or into any other model, modeling
C system, or component of any modeling system, including those that purport to
C emulate UAM-V, or(c) to apply the UAM-V modeling system to regions that
C entirely exclude the United States of America is expressly forbidden. Also,
C downloading the UAM-V modeling system to any location outside the United States
C and/or transfering this or any other copy of the UAM-V modeling system to any
C third party, including any non-EPA electronic bulletin board, website or other
C server, are both expressly forbidden. 
C
C Any failure to comply with the foregoing restrictions may result in severe
C civil and/or criminal penalties. 17 U.S.C. section 506.
C
C Questions reguarding allowable research applications and authorized uses that
C rely on version 1.24 of the UAM-V modeling system or components thereof should
C be directed to Ms. Sharon Douglas at (415) 507-7108.
C
C Additional information about U.S. and worldwide applications and research
C development of the UAM-V modeling system can be obtained from Systems
C Applications International, Inc. at http://www.icfkaiser.com/ or by sending
C your name,affiliation,address,telephone number and e-mail address to Systems
C Applications International, Inc. 101 Lucas Valley Road, San Rafael CA 94947.
C
CDECK.PRELND
C
C  DATE: OCTOBER 1991, rev July 92
C  VERSION: UAM-V, v2
C
C     SURFACE CHARACTERISTICS PREPREPROCESSOR
C     THIS PROGRAM TAKES THE GIS LAND COVER DATA BASE
C     WHICH CONVERS THE ENTIRE USA AND MAPS IN INTO
C     THE MESOSCALE MODELING DOMAIN IN THE ROCKY MOUNTAIN
C     THE LAND USE DATA ARE CONVERTED INTO THE RADM LAND
C     USE CLASSES AND A GRID CELL AVERAGE SURFACE ROUGHNESS
C     FIELD IS ALSO OUTPUT FOR THE METEOROLOGICAL MODEL
C
C....Modified to write UAMV surface file
C....Surface roughness is written in meters ---RRS 911001
c....write of surface roughness eliminated --tcm, 920717
* modified to accept lat/lon input, hpd, 960116
C  SUBROUTINES CALLED:
C                   GUTM
C
C
      real*4, allocatable :: Z0(:,:)
      real*4, allocatable :: PLAND(:,:,:)
      real*4, allocatable :: DUM(:,:)
      DIMENSION PTS(2,4)
      REAL lpts(2,4),lnmin,ltmin,lnmax,ltmax,lat,lon
      COMMON /DATA4/ UTMX1,UTMY1,UTMX2,UTMY2,UTMX3,UTMY3,UTMX4,UTMY4
      EQUIVALENCE (PTS(1,1),UTMX1)
      DIMENSION IPERC(11)
      DIMENSION TOT(11)
      DIMENSION Z00(11)
      DIMENSION IZ(25)
      LOGICAL LATLON
      CHARACTER*10 IDRUN
      CHARACTER*20 NAMLND(11)
      CHARACTER*80 FN
C
C     GIS DATA BASE HAS
C     11 LAND USE CLASSES:   URBAN
C                            AGRICULTURE
C                            RANGELAND
C                            DECIDUOUS FOREST
C                            CONFIEROUS FOREST
C                            MIXED FOREST
C                            WATER
C                            BARREN LAND
C                            NON-FORESTED WETLAND
C                            MIXED AG-RANGELAND
C                            ROCKY OPEN AREAS WITH LOW SHRUBS AND LICHENS
C
C
      DATA NAMLND /'URBAN               ',
     1            'AGRICULTURE         ',
     2            'RANGELAND           ',
     3            'DECIDUOUS FOREST    ',
     4            'CONIFEROUS FOREST   ',
     5            'MIXED FORESTED      ',
     6            'WATER               ',
     7            'BARREN LAND         ',
     8            'NON-FORRESTED WETLND',
     9            'MIXED AG-RANGELAND  ',
     &            'ROCKY OPEN AREAS    '/
C
C
C
C
C     SURFACE ROUGHNESS VALUES (CM) BY GIS LAND USE TYPOE
C... ARGONNE Surface Roughness Data
      DATA Z00/300.0,25.0,5.0,100.0,100.0,100.0,0.01,0.2,15.0,10.0,10./
C
C     OPEN FILES
C
      OPEN(UNIT=11,FILE='PLND.IN',FORM='FORMATTED')
      READ(11,1111) FN
      OPEN(UNIT=7,FILE=FN,FORM='FORMATTED')
      READ(11,1111) FN
      OPEN(UNIT=12,FILE=FN,FORM='FORMATTED')
      READ(11,1111) FN
      OPEN(UNIT=8,FILE=FN,FORM='UNFORMATTED')
1111  FORMAT(A80)
C
      DLAT=1./12.+1.E-6
      DLONG=1./8.+1.E-6
C
C     READ IN GRID DEFINITION
C
      READ(11,'(L)') latlon
      WRITE(*,'(L)') latlon
      IF(latlon) THEN
        READ(11,'(a80)') FN
        READ(FN,'(4f,2i)') lnmin,ltmin,lnmax,ltmax,NXC,NYC
        WRITE(*,1005) lnmin,ltmin,lnmax,ltmax,NXC,NYC
        cx=(lnmax-lnmin)/FLOAT(nxc)
        cy=(ltmax-ltmin)/FLOAT(nyc)
        WRITE(*,*)'cx,cy :',cx,cy
      ELSE
        READ(11,1002) XO,YO,IZONE,ICS,NXC,NYC
        WRITE(*,3002) XO,YO,IZONE,ICS,NXC,NYC
3002  FORMAT(2F10.3,4I10)
1002  FORMAT(2F10.0,4I10)
 1005 FORMAT(4f10.3,2I10)
        IXO=NINT(XO)
        IYO=NINT(YO)
        IBSZN=IZONE
C
C     WRITE OUT SUMMARY INFORMATION
C
        WRITE(12,2101) IBSZN,IXO,IBSZN,IYO,NXC,NYC,ICS
2101  FORMAT(1H1,//,10X,'***SUMMARY GRID INFORMATION FOR PROGRAM PRELND'
     1,'-LANDUSE PREPROCESSOR ',/,20X,'UTM ZONE ',I2,' X ORIGIN=',I5,' (
     2KM)',/,20X,'UTM ZONE ',I2,' Y ORIGIN=',I5,' (KM)',/,20X
     2,'NUMBER OF X GRIDS =',I5
     3,/,20X,'NUMBER OF Y GRIDS =',I5,/,20X,'GRID CELL SPACING =',I4
     4,' (KM)')
      ENDIF
c
c  allocate space for x-y arrays
c
      allocate (z0(nxc,nyc), dum(nxc,nyc))
      allocate (pland(11,nxc,nyc))
C
C     FIRST CONVERT UNITS FROM CM TO M
C
      DO J=1,11
        Z00(J)=Z00(J)*0.01
        do k=1,nxc         ! initialize
          do i=1,nyc
            pland(j,k,i)=0.0
          enddo
        enddo
      enddo
      do j=1,nyc
        do i=1,nxc
          z0(i,j) = 0.0001
        enddo
      enddo
C
C     DETERMINE WINDOW FOR LOOKING AT GIS DATA
C
      IF(.not.latlon) THEN
        UTMX=FLOAT(IXO)
        UTMY=FLOAT(IYO)
        CALL MAPUTG(UTMX,UTMY,IZONE,ALONG,ALAT)
        ALNMN=ALONG
        ALTMN=ALAT
        ALNMX=ALONG
        ALTMX=ALAT
        UTMX=UTMX+FLOAT(NXC*ICS)
        CALL MAPUTG(UTMX,UTMY,IZONE,ALONG,ALAT)
        ALNMN=AMIN1(ALONG,ALNMN)
        ALTMN=AMIN1(ALAT,ALTMN)
        ALNMX=AMAX1(ALONG,ALNMX)
        ALTMX=AMAX1(ALAT,ALTMX)
C
        UTMY=UTMY+FLOAT(NYC*ICS)
        CALL MAPUTG(UTMX,UTMY,IZONE,ALONG,ALAT)
        ALNMN=AMIN1(ALONG,ALNMN)
        ALTMN=AMIN1(ALAT,ALTMN)
        ALNMX=AMAX1(ALONG,ALNMX)
        ALTMX=AMAX1(ALAT,ALTMX)
C
        UTMX=FLOAT(IXO)
        CALL MAPUTG(UTMX,UTMY,IZONE,ALONG,ALAT)
        ALNMN=AMIN1(ALONG,ALNMN)
        ALTMN=AMIN1(ALAT,ALTMN)
        ALNMX=AMAX1(ALONG,ALNMX)
        ALTMX=AMAX1(ALAT,ALTMX)
*
*        LNMIN=INT(ALNMN)-1
*        LNMAX=INT(ALNMX)+2
*        LTMIN=INT(ALTMN)-1
*        LTMAX=INT(ALTMX)+2
        lnmin=alnmn-1.
        lnmax=alnmx+2.
        ltmin=altmn-1.
        ltmax=altmx+2.
      ENDIF
*
* write out window
      WRITE(12,'(a,4f10.3)') 'WINDOW: lat1,lon1,lat2,lon2 = ',
     &                       ltmin,lnmin,ltmax,lnmax
      WRITE(*,'(a,4f10.3)') 'WINDOW: lat1,lon1,lat2,lon2 = ',
     &                       ltmin,lnmin,ltmax,lnmax
C
C
C     READ IN GIS DATA
C
      KNT=0
100   CONTINUE
      READ(7,1000,END=500) LAT1,LAT2,LON1,LON2,IPERC
* hpd 11 goes to 12
1000  FORMAT(4I4,12I5)
*      IF (FLOAT(LAT1).LT.LTMIN) GO TO 100
*      IF (FLOAT(LAT1).GT.LTMAX) GO TO 100
*      IF (FLOAT(-LON1).LT.LNMIN) GO TO 100
*      IF (FLOAT(-LON1).GT.LNMAX) GO TO 100
      ALAT1=FLOAT(LAT1)+FLOAT(LAT2)/12.0-DLAT
      ALONG1=-(FLOAT(LON1)+FLOAT(LON2)/8.0)-DLONG
      ALAT2=FLOAT(LAT1)+FLOAT(LAT2)/12.0+DLAT
      ALONG2=-(FLOAT(LON1)+FLOAT(LON2)/8.0)+DLONG
      IF (ALAT2.LT.LTMIN) GO TO 100
      IF (ALAT1.GT.LTMAX) GO TO 100
      IF (ALONG2.LT.LNMIN) GO TO 100
      IF (ALONG1.GT.LNMAX) GO TO 100
      IF(.not.latlon) THEN
        CALL GUTM(ALONG1,ALAT1,IZONE,UTMX1,UTMY1)
        CALL GUTM(ALONG2,ALAT1,IZONE,UTMX2,UTMY2)
        CALL GUTM(ALONG2,ALAT2,IZONE,UTMX3,UTMY3)
        CALL GUTM(ALONG1,ALAT2,IZONE,UTMX4,UTMY4)
        UTXMN=AMIN1(UTMX1,UTMX2,UTMX3,UTMX4)
        UTYMN=AMIN1(UTMY1,UTMY2,UTMY3,UTMY4)
        UTXMX=AMAX1(UTMX1,UTMX2,UTMX3,UTMX4)
        UTYMX=AMAX1(UTMY1,UTMY2,UTMY3,UTMY4)
C
        I1=(UTXMN-FLOAT(IXO))/FLOAT(ICS) - 2
        I2=(UTXMX-FLOAT(IXO))/FLOAT(ICS) + 2
        J1=(UTYMN-FLOAT(IYO))/FLOAT(ICS) - 2
        J2=(UTYMX-FLOAT(IYO))/FLOAT(ICS) + 2
        I1=MAX0(I1,1)
        I2=MIN0(I2,NXC)
        J1=MAX0(J1,1)
        J2=MIN0(J2,NYC)
      ELSE
        I1=NINT((along1-lnmin)/(cx) - 2.)
        I2=NINT((along2-lnmin)/(cx) + 2.)
        J1=NINT((alat1-ltmin)/(cy) - 2.)
        J2=NINT((alat2-ltmin)/(cy) + 2.)
        I1=MAX0(I1,1)
        I2=MIN0(I2,NXC)
        J1=MAX0(J1,1)
        J2=MIN0(J2,NYC)
        lpts(1,1)=along1
        lpts(2,1)=alat1
        lpts(1,2)=along2
        lpts(2,2)=alat1
        lpts(1,3)=along2
        lpts(2,3)=alat2
        lpts(1,4)=along1
        lpts(2,4)=alat2
      ENDIF

C
C     CHECK IF NEAR OUR REGION
C
      IF (I2.LT.1) GO TO 100
      IF (I1.GT.NXC) GO TO 100
      IF (J2.LT.1) GO TO 100
      IF (J1.GT.NYC) GO TO 100
C
c     WRITE(*,3301) I1,I2,J1,J2,LON1,LON2,LAT1,LAT2
c3301  FORMAT(' WINDOW ',8I5)
      DO 200 J=J1,J2
        IF(latlon) THEN
          lat=ltmin+(FLOAT(j)-0.5)*cy
        ELSE
          UTMY=FLOAT(IYO)+(FLOAT(J)-0.5)*FLOAT(ICS)
        ENDIF
        DO 200 I=I1,I2
          IF(latlon) THEN
            lon=lnmin+(FLOAT(i)-0.5)*cx
          ELSE 
            UTMX=FLOAT(IXO)+(FLOAT(I)-0.5)*FLOAT(ICS)
          ENDIF
          IF(latlon) THEN
            IF (INSIDE(lon,lat,4,lpts).eq.0) GOTO 200
          ELSE
            IF (INSIDE(UTMX,UTMY,4,PTS).EQ.0) GO TO 200
          ENDIF
C
C     FOUND THIS GRID CELL
C
      PLAND(1,I,J)=FLOAT(IPERC(1))/100.0
      PLAND(2,I,J)=FLOAT(IPERC(2))/100.0
      PLAND(3,I,J)=FLOAT(IPERC(3))/100.0
      PLAND(4,I,J)=FLOAT(IPERC(4))/100.0
      PLAND(5,I,J)=FLOAT(IPERC(5))/100.0
      PLAND(6,I,J)=float(iperc(6))/100.0
      PLAND(7,I,J)=FLOAT(IPERC(7))/100.0
      PLAND(8,I,J)=FLOAT(IPERC(8))/100.0
      PLAND(9,I,J)=FLOAT(IPERC(9))/100.0
      PLAND(10,I,J)=FLOAT(IPERC(10))/100.0
      PLAND(11,I,J)=FLOAT(IPERC(11))/100.0
      Z0AVG=0.0
      DO 150 K=1,11
      Z0AVG=Z0AVG+(FLOAT(IPERC(K))/100.0)*ALOG(Z00(K))
150   CONTINUE
      Z0(I,J)=EXP(Z0AVG)
      if (z0(i,j) .lt. 1.e-6) z0(i,j) = 0.0001
c
200   CONTINUE
      GO TO 100
500   CONTINUE
      CALL SMOOTH(Z0,DUM,NXC,NYC,2.)
      CALL SMOOTH(DUM,Z0,NXC,NYC,2.)
C
C     CALCULATE TOTAL LAND USE TYPES FOR THIS REGION
C
      Z0AVG=0.0
      Z0MAX=-1.E20
      Z0MIN=1.E20
      DO 290 K=1,11
         TOT(K)=0.0
290   CONTINUE
      DO 300 J=1,NYC
        DO 300 I=1,NXC
          Z0AVG=Z0AVG+Z0(I,J)
          Z0MAX=AMAX1(Z0MAX,Z0(I,J))
          Z0MIN=AMIN1(Z0MIN,Z0(I,J))
c...WILL NOT STOP PROGRAM IF Z0<=0.  ....RRS 911009..set equal to water
          IF (Z0(I,J).LE.0.0) THEN
            WRITE(12,3000) I,J
            z0(i,j)=0.01
3000        FORMAT(' ERROR IN CELL ',2I5)
c           STOP 'ERROR'
          ENDIF
c
c   make sure land uses sum to 1.
c
          psum = 0.
          do k=1,11
            psum = psum + pland(k,i,j)
          enddo
          if (psum .le. 0.) then
            do k=1,11
              pland(k,i,j) = 0.
            enddo
            pland(7,i,j) = 1.
          else
            do k=1,11
              pland(k,i,j) = pland(k,i,j)/psum
            enddo
          endif
C
          DO 310 K=1,11
             TOT(K)=TOT(K)+PLAND(K,I,J)/FLOAT(NXC*NYC)
310       CONTINUE
300   CONTINUE
c
      WRITE(12,2000) Z0MAX,Z0MIN,Z0AVG
2000  FORMAT(/,5X,' SURFACE ROUGHNESS MAX,MIN,AVG (M)='
     1,3E12.4)
      WRITE(12,2800)
2800  FORMAT(//,5X,'PERCENT COVERAGE OF LAND USE CLASSES IN MESOSCALE'
     1,' MODELING DOMAIN',//,5X,'LAND USE CLASS',11X,'PERCENT',/)
      DO 299 K=1,11
         PP=100.0*TOT(K)
         WRITE(12,2900) NAMLND(K),PP
299   CONTINUE
2900  FORMAT(5X,A20,F10.3)
      NPAN=NXC/26+1
      DO 390 IPAN=1,NPAN
      I1=25*(IPAN-1)+1
      I2=I1+24
      I2=MIN0(I2,NXC)
      WRITE(12,2300) (I,I=I1,I2)
2300  FORMAT(1H1,/,' SURFACE ROUGHNESS VALUES (CM)'
     1,' FOR THE MESOSCALE MODELING DOMAIN '
     2,/,6X,25(2X,I3),/,6X,25('  ---'))
      DO 350 JJ=1,NYC
      J=NYC-JJ+1
      II=0
      DO 360 I=I1,I2
         II=II+1
         IZ(II)=NINT(Z0(I,J)*100.0)
360   CONTINUE
      WRITE(12,2200) J,(IZ(I),I=1,II)
350   CONTINUE
390   CONTINUE
2200  FORMAT(1X,I2,' : ',25I5)
C
      write(*,*)'Writing surface data: ',nxc,nyc
Ctcm   UAM-V no longer requires roughness as input
Ctcm      WRITE(8) ((Z0(I,J),I=1,NXC),J=1,NYC)
      WRITE(8) (((PLAND(K,I,J),I=1,NXC),J=1,NYC),k=1,11)
      do i=1,nxc
        do j=1,nyc
          write(*,5000) i,j,(PLAND(k,i,j), k=1,11)
        enddo
      enddo
 5000 format(i5,i5,2x,11f10.4)
      STOP
      END

