CDECK VVGTU1
C                           PRELND3 VERSION 2.0
C                  COPYRIGHT  1996  ALL RIGHTS RESERVED        
C                 SYSTEMS APPLICATIONS INTERNATIONAL, INC. 
C                           December 30, 1996
      SUBROUTINE VVGTU1
C
C     *** SETS UP COEFFICIENTS FOR CONVERTING GEODETIC TO
C         RECTIFYING LATITUDE AND CONVERSELY
C
C         A1-A4 COEFFICIENTS FOR CONVERTING GEODITIC TO RECTIFYING LATIT
C         A5    FALSE EASTING
C         A6    FALSE NORTHING
C         A8    SCALE FACTOR AT CENTRAL MERIDIAN
C         A9    CENTRAL MERIDIAN IN SECONDS
C         A10   RADIUS OF SPHERE HAVING GREAT CIRCLE LENGTH EQUAL TO
C               SPHEROID MERIDIAN LENGTH
C         A11-A14  COEFFICIENTS FOR CONVERTING RECTIFYING LATITUDE TO
C                  GEODETIC LATITUDE
C         A15   SEMIMAJOR AXIS OF SPHERIOD
C         A16   ECCENTRICITY SQUARED
C
C
      COMMON /VVUTM/ A(16)
      DATA IFRST/1/
C
C     *** CONPUTE COEFFICIENTS ON FIRST PASS ONLY
      IF (IFRST .NE. 1) RETURN
      IFRST = 0
C
      A(5)=5.0E5
      A(6)=0.0
      A(7)=0.0
      A(8)=0.9996
C
C     *** CLARKE 1866 ELLIPSOID AXES LENGTHS
      A(15)=6378206.4
      B = 6356583.80
C
      A(16)= ((A(15)-B)/A(15))*((A(15)+B)/A(15))
      A(10)=(((A(16)*(7.0/3.2E1)+(5.0/1.6E1))*A(16)+0.5)*A(16)
     $ +1.0)*A(16)*0.25
      A(1)=-(((A(10)*(1.95E2/6.4E1)+3.25)*A(10)+3.75)*A(10)+3.0)*
     $ A(10)
      A(2)=(((1.455E3/3.2E1)*A(10)+(7.0E1/3.0))*A(10)+7.5)*A(10)**2
      A(3)=-((7.0E1/3.0)+A(10)*(9.45E2/8.0))*A(10)**3
      A(4)=(3.15E2/4.0)*A(10)**4
      A(11)=(((7.75-(6.57E2/6.4E1)*A(10))*A(10)-5.25)*A(10)+3.0)*
     $ A(10)
      A(12)=(((5.045E3/3.2E1)*A(10)-(1.51E2/3.0))*A(10)+10.5)*
     $ A(10)**2
      A(13)=((1.51E2/3.0)-(3.291E3/8.0)*A(10))*A(10)**3
      A(14)=(1.097E3/4.0)*A(10)**4
      FAC=A(10)*A(10)
      A(10)=(((2.25E2/6.4E1)*FAC+2.25)*FAC+1.0)*(1.0-FAC)*
     $ (1.0-A(10))*A(15)
      RETURN
      END
